import { __esDecorate, __runInitializers } from "tslib";
import { describe, expect, it, jest } from "@jest/globals";
jest.unstable_mockModule("./ServicesRegistry.js", () => ({
    ServicesRegistry: {
        register: jest.fn(),
        has: jest.fn(),
        get: jest.fn(),
    },
}));
const { injectable } = await import("./injectable.js");
const { ServicesRegistry } = await import("./ServicesRegistry.js");
describe("injectable", () => {
    it("should be defined", () => {
        expect(injectable).toBeDefined();
    });
    it("should register service", () => {
        let Test = (() => {
            let _classDecorators = [injectable()];
            let _classDescriptor;
            let _classExtraInitializers = [];
            let _classThis;
            var Test = class {
                static { _classThis = this; }
                static {
                    const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(null) : void 0;
                    __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
                    Test = _classThis = _classDescriptor.value;
                    if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
                    __runInitializers(_classThis, _classExtraInitializers);
                }
            };
            return Test = _classThis;
        })();
        expect(ServicesRegistry.register).toBeCalledWith(Test, {
            name: "Test",
            dependencies: [],
        });
    });
    it("should register service with dependencies", () => {
        class Dep {
        }
        let Test = (() => {
            let _classDecorators = [injectable(() => [Dep])];
            let _classDescriptor;
            let _classExtraInitializers = [];
            let _classThis;
            var Test = class {
                static { _classThis = this; }
                static {
                    const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(null) : void 0;
                    __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
                    Test = _classThis = _classDescriptor.value;
                    if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
                    __runInitializers(_classThis, _classExtraInitializers);
                }
            };
            return Test = _classThis;
        })();
        expect(ServicesRegistry.register).toBeCalledWith(Test, {
            name: "Test",
            dependencies: [Dep],
        });
    });
    it("should register service with ts legacy decorator", () => {
        class Test {
        }
        injectable()(Test);
        expect(ServicesRegistry.register).toBeCalledWith(Test, {
            name: "Test",
            dependencies: [],
        });
    });
});
//# sourceMappingURL=injectable.test.js.map